/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2010 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id$
 *
 ******************************************************************************/
package it.tidalwave.semantic.test;

import it.tidalwave.semantic.other.Repository;
import it.tidalwave.semantic.other.Relation;
//import static org.mockito.Mockito.*;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public abstract class RelationTestSupport<C extends Repository, R extends Relation> extends TestSupport<C>
  {
//    private Type type1;
//    private Type type2;
//    protected R rel1;
//    protected R rel2;
//    private Relationable r1;
//    private Relationable r2;
//    private Relationable r3;
//    private Relationable r4;
//
//    @Before
//    public void setUp()
//      {
//        type1 = context.findOrCreateType(new Id("t1"), "type 1");
//        type2 = context.findOrCreateType(new Id("t2"), "type 2");
//        r1 = mock(Relationable.class);
//        r2 = mock(Relationable.class);
//        r3 = mock(Relationable.class);
//        r4 = mock(Relationable.class);
//        stub(r1.toString()).toReturn("r1");
//        stub(r2.toString()).toReturn("r2");
//        stub(r3.toString()).toReturn("r3");
//        stub(r4.toString()).toReturn("r4");
////        stub(r1.hashCode()).toReturn(7);
////        stub(r2.hashCode()).toReturn(11);
////        stub(r3.hashCode()).toReturn(13);
////        stub(r4.hashCode()).toReturn(17);
//        rel1 = (R)context.createRelation(type1, r1, r2);
//        rel2 = (R)context.createRelation(type2, r3, r4);
//      }
//
//    @Test
//    public void testGetType()
//      {
//        assertSame(type1, rel1.getType());
//        assertSame(type2, rel2.getType());
//      }
//
//    @Test
//    public void testGetSubject()
//      {
//        assertSame(r1, rel1.getSubject());
//        assertSame(r3, rel2.getSubject());
//      }
//
//    @Test
//    public void testGetObject()
//      {
//        assertSame(r2, rel1.getObject());
//        assertSame(r4, rel2.getObject());
//      }
//
//    @Test
//    public void testGetDisplayName()
//      {
//        final Type spy = spy(rel1.type);
//        spy.getDisplayName();
//        verify(spy).getDisplayName();
//        verifyNoMoreInteractions(spy);
//      }
//
//    @Test
//    public void testGetDisplayName_Locale()
//      {
//        final Locale locale = Locale.ITALY;
//        final Type spy = spy(rel1.type);
//        spy.getDisplayName(locale);
//        verify(spy).getDisplayName(same(locale));
//        verifyNoMoreInteractions(spy);
//      }
//
//    @Test
//    public void testGetLocales()
//      {
//        final Type spy = spy(rel1.type);
//        spy.getLocales();
//        verify(spy).getLocales();
//        verifyNoMoreInteractions(spy);
//      }
//
//    @Test
//    public void testCompareTo()
//      {
//        assertEquals(-1, rel1.compareTo(rel2));
//        assertEquals(+1, rel2.compareTo(rel1));
//      }
//
//    @Test
//    public void testEquals()
//      {
//        assertFalse(rel1.equals(rel2));
//        assertFalse(rel2.equals(rel1));
//      }
//
//    @Test
//    public void testHashCode()
//      {
////        assertEquals(-1918297114, rel1.hashCode());
////        assertEquals(-1287182594L, rel2.hashCode());
//      }
//
//    @Test
//    public void testToString()
//      {
//        assertEquals("SimpleRelation[r1 SimpleEntityType[t1, type 1] r2]", rel1.toString());
//        assertEquals("SimpleRelation[r3 SimpleEntityType[t2, type 2] r4]", rel2.toString());
//      }
  }
